#line 1 "dfa_riscv.cpp"
//
// Copyright (c) 2003, 2020, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2014, 2020, Red Hat Inc. All rights reserved.
// Copyright (c) 2020, 2022, Huawei Technologies Co., Ltd. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_riscv.hpp"
#include "opto/cfgnode.hpp"
#include "opto/intrinsicnode.hpp"
#include "opto/matcher.hpp"
#include "opto/narrowptrnode.hpp"
#include "opto/opcodes.hpp"
#include "opto/convertnode.hpp"

//------------------------- Source -----------------------------------------

//------------------------- Attributes -------------------------------------

// AttributeForm 
static const int op_cost = 1;

// AttributeForm 
static const int ins_cost = DEFAULT_COST;

// AttributeForm 
static const int ins_size = 32;

// AttributeForm 
static const int ins_short_branch = 0;

// AttributeForm 
static const int ins_alignment = 4;

//------------------------- Macros -----------------------------------------
#define DFA_PRODUCTION(result, rule, cost)\
  _cost[ (result) ] = cost; _rule[ (result) ] = rule;

#define DFA_PRODUCTION__SET_VALID(result, rule, cost)\
  DFA_PRODUCTION( (result), (rule), (cost) ); STATE__SET_VALID( (result) );

//------------------------- DFA --------------------------------------------
// DFA is a large switch with case statements for each ideal opcode encountered
// in any match rule in the ad file.  Each case has a series of if's to handle
// the match or fail decisions.  The matches test the cost function of that
// rule, and prune any cases which are higher cost for the same reduction.
// In order to generate the DFA we walk the table of ideal opcode/MatchList
// pairs generated by the ADLC front end to build the contents of the case
// statements (a series of if statements).


void  State::_sub_Op_RegN(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGN, iRegN_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegN_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegN_rule, c)
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegI(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGIHEAPBASE, iRegIHeapbase_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGI_R14, iRegI_R14_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGI_R13, iRegI_R13_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGI_R12, iRegI_R12_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGI_R10, iRegI_R10_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegP(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R28, iRegP_R28_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R16, iRegP_R16_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R15, iRegP_R15_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R14, iRegP_R14_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R13, iRegP_R13_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R12, iRegP_R12_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R11, iRegP_R11_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R10, iRegP_R10_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, javaThread_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, inline_cache_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegF(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(FREGF, fRegF_rule, c)
    }
}
void  State::_sub_Op_RegD(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(FREGD, fRegD_rule, c)
    }
}
void  State::_sub_Op_RegL(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGL_R10, iRegL_R10_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, iRegLNoSp_rule, c+1)
        DFA_PRODUCTION__SET_VALID(IREGL, iRegL_rule, c+1)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c+1)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c+1)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, iRegL_R28_rule, c+1)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, iRegL_R29_rule, c+1)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, iRegL_R30_rule, c+1)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c+1)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGL_R30, iRegL_R30_rule, c)	  // overwrites higher cost rule
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGL_R29, iRegL_R29_rule, c)	  // overwrites higher cost rule
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGL_R28, iRegL_R28_rule, c)	  // overwrites higher cost rule
    }
    {
      unsigned int c = 1;
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGL, iRegL_rule, c)	  // overwrites higher cost rule
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)	  // overwrites higher cost rule
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_RegFlags(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, rFlagsReg_rule, c)
    }
}
void  State::_sub_Op_AbsD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(FREGD, absD_reg_rule, c)
    }
}
void  State::_sub_Op_AbsF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(FREGF, absF_reg_rule, c)
    }
}
void  State::_sub_Op_AbsI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) &&
        (
#line 352 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 241 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+ALU_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, absI_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, absI_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, absI_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, absI_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, absI_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, absI_reg_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+ALU_COST * 3;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, absI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, absI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, absI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, absI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, absI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, absI_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AbsL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) &&
        (
#line 370 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 294 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+ALU_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, absL_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, absL_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, absL_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, absL_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, absL_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, absL_reg_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+ALU_COST * 3;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, absL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, absL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, absL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, absL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, absL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, absL_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD] + FMUL_DOUBLE_COST;
        DFA_PRODUCTION__SET_VALID(FREGD, addD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_AddF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF] + FMUL_SINGLE_COST;
        DFA_PRODUCTION__SET_VALID(FREGF, addF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_AddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CONVL2I_IREGL_) && STATE__VALID_CHILD(_kids[1], IMMIADD) ) {
      unsigned int c = _kids[0]->_cost[_CONVL2I_IREGL_]+_kids[1]->_cost[IMMIADD] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, addI_reg_imm_l2i_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, addI_reg_imm_l2i_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, addI_reg_imm_l2i_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, addI_reg_imm_l2i_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, addI_reg_imm_l2i_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, addI_reg_imm_l2i_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMIADD) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMIADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, addI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, addI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, addI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, addI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, addI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, addI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, addI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, addI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, addI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, addI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, addI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, addI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL__CONVI2L_IREGI__IMMISCALE) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 217 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 436 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL__CONVI2L_IREGI__IMMISCALE]+_kids[1]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, shaddL_reg_reg_ext_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, shaddL_reg_reg_ext_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, shaddL_reg_reg_ext_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, shaddL_reg_reg_ext_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, shaddL_reg_reg_ext_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, shaddL_reg_reg_ext_b_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_IREGI__IMMISCALE) &&
        (
#line 217 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 453 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LSHIFTL__CONVI2L_IREGI__IMMISCALE] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, shaddL_reg_reg_ext_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, shaddL_reg_reg_ext_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, shaddL_reg_reg_ext_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, shaddL_reg_reg_ext_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, shaddL_reg_reg_ext_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, shaddL_reg_reg_ext_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMISCALE) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 199 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 488 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMISCALE]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, shaddL_reg_reg_b_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, shaddL_reg_reg_b_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, shaddL_reg_reg_b_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, shaddL_reg_reg_b_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, shaddL_reg_reg_b_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, shaddL_reg_reg_b_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMISCALE) &&
        (
#line 199 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 523 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMISCALE] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, shaddL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, shaddL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, shaddL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, shaddL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, shaddL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, shaddL_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLADD) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, addL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, addL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, addL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, addL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, addL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, addL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, addL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, addL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, addL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, addL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, addL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, addL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_IREGI__IMMISCALE) &&
        (
#line 180 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 620 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_LSHIFTL__CONVI2L_IREGI__IMMISCALE] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R11, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R12, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R13, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R14, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R15, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R16, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R28, shaddP_reg_reg_ext_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMISCALE) &&
        (
#line 162 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 645 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMISCALE] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R11, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R12, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R13, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R14, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R15, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R16, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R28, shaddP_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMLADD) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMLADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R11, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R12, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R13, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R14, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R15, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R16, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R28, addP_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R11, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R12, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R13, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R14, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R15, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R16, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R28, addP_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], JAVATHREAD_REGP) && STATE__VALID_CHILD(_kids[1], IMML_PC_OFF) ) {
      unsigned int c = _kids[0]->_cost[JAVATHREAD_REGP]+_kids[1]->_cost[IMML_PC_OFF];
        DFA_PRODUCTION__SET_VALID(THREAD_ANCHOR_PC, thread_anchor_pc_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], IMMLOFFSET) &&
        
#line 3234 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
Universe::narrow_oop_shift() == 0
#line 816 "dfa_riscv.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[IMMLOFFSET];
        DFA_PRODUCTION__SET_VALID(INDOFFLN, indOffLN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffLN_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], IMMIOFFSET) &&
        
#line 3219 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
Universe::narrow_oop_shift() == 0
#line 828 "dfa_riscv.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[IMMIOFFSET];
        DFA_PRODUCTION__SET_VALID(INDOFFIN, indOffIN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffIN_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMLOFFSET) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMLOFFSET];
        DFA_PRODUCTION__SET_VALID(INDOFFL, indOffL_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMIOFFSET) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMIOFFSET];
        DFA_PRODUCTION__SET_VALID(INDOFFI, indOffI_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffI_rule, c)
      }
    }
}
void  State::_sub_Op_AndI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMIPOWEROF2) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMIPOWEROF2];
        DFA_PRODUCTION__SET_VALID(_ANDI_IREGIORL2I_IMMIPOWEROF2, _AndI_iRegIorL2I_immIpowerOf2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_IREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 389 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 860 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORI_IREGI_IMMI_M1]+_kids[1]->_cost[IREGI] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, andnI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, andnI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, andnI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, andnI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, andnI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, andnI_reg_reg_b_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _XORI_IREGI_IMMI_M1) &&
        (
#line 389 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 878 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_XORI_IREGI_IMMI_M1] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, andnI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, andnI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, andnI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, andnI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, andnI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, andnI_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_16BITS) &&
        (
#line 75 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 916 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI_16BITS] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convS2UI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, convS2UI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, convS2UI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, convS2UI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, convS2UI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, convS2UI_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMIADD) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMIADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, andI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, andI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, andI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, andI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, andI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, andI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, andI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AndL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _XORL_IREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 405 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 1022 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORL_IREGL_IMML_M1]+_kids[1]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, andnL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, andnL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, andnL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, andnL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, andnL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, andnL_reg_reg_b_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _XORL_IREGL_IMML_M1) &&
        (
#line 405 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 1039 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_XORL_IREGL_IMML_M1] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, andnL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, andnL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, andnL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, andnL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, andnL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, andnL_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGIORL2I_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) &&
        (
#line 90 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 1074 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGIORL2I_]+_kids[1]->_cost[IMML_32BITS] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, convI2UL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, convI2UL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, convI2UL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, convI2UL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, convI2UL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, convI2UL_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGIORL2I_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGIORL2I_]+_kids[1]->_cost[IMML_32BITS]+ALU_COST * 2;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, convI2UL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, convI2UL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, convI2UL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, convI2UL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, convI2UL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, convI2UL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLADD) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, andL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, andL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, andL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, andL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, andL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, andL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, andL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, andL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, andL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, andL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, andL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, andL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__LOADI_MEMORY__) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__LOADI_MEMORY__]+_kids[1]->_cost[IMML_32BITS] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, loadUI2L_rule, c)
      }
    }
}
void  State::_sub_Op_AryEq(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_R11) && STATE__VALID_CHILD(_kids[1], IREGP_R12) &&
        (
#line 10070 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
((AryEqNode*)n)->encoding() == StrIntrinsicNode::UU
#line 1231 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R11]+_kids[1]->_cost[IREGP_R12] + DEFAULT_COST;
        DFA_PRODUCTION__SET_VALID(IREGI_R10, array_equalsC_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R11) && STATE__VALID_CHILD(_kids[1], IREGP_R12) &&
        (
#line 10053 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
((AryEqNode*)n)->encoding() == StrIntrinsicNode::LL
#line 1240 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R11]+_kids[1]->_cost[IREGP_R12] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, array_equalsB_rule, c)
      }
    }
}
void  State::_sub_Op_Binary(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_R11) && STATE__VALID_CHILD(_kids[1], IREGP_R13) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R11]+_kids[1]->_cost[IREGP_R13];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGP_R11_IREGP_R13, _Binary_iRegP_R11_iRegP_R13_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R13) && STATE__VALID_CHILD(_kids[1], IMMI_1) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R13]+_kids[1]->_cost[IMMI_1];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGP_R13_IMMI_1, _Binary_iRegP_R13_immI_1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R13) && STATE__VALID_CHILD(_kids[1], IMMI_LE_4) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R13]+_kids[1]->_cost[IMMI_LE_4];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGP_R13_IMMI_LE_4, _Binary_iRegP_R13_immI_le_4_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R13) && STATE__VALID_CHILD(_kids[1], IREGI_R14) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R13]+_kids[1]->_cost[IREGI_R14];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGP_R13_IREGI_R14, _Binary_iRegP_R13_iRegI_R14_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R11) && STATE__VALID_CHILD(_kids[1], IREGI_R12) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R11]+_kids[1]->_cost[IREGI_R12];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGP_R11_IREGI_R12, _Binary_iRegP_R11_iRegI_R12_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGLNOSP) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGLNOSP]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGLNOSP_IREGL, _Binary_iRegLNoSp_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPUL_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPUL_IREGL_IREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPU__CMPUL_IREGL_IREGL, _Binary_cmpOpU__CmpUL_iRegL_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_IREGL_IREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP__CMPL_IREGL_IREGL, _Binary_cmpOp__CmpL_iRegL_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPU_IREGI_IREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPU__CMPU_IREGI_IREGI, _Binary_cmpOpU__CmpU_iRegI_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGINOSP) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGINOSP]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGINOSP_IREGI, _Binary_iRegINoSp_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_IREGI_IREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP__CMPI_IREGI_IREGI, _Binary_cmpOp__CmpI_iRegI_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], _NEGD_FREGD_) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[_NEGD_FREGD_];
        DFA_PRODUCTION__SET_VALID(_BINARY_FREGD__NEGD_FREGD_, _Binary_fRegD__NegD_fRegD__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGD_FREGD_) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[_NEGD_FREGD_]+_kids[1]->_cost[FREGD];
        DFA_PRODUCTION__SET_VALID(_BINARY__NEGD_FREGD__FREGD, _Binary__NegD_fRegD__fRegD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], _NEGF_FREGF_) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[_NEGF_FREGF_];
        DFA_PRODUCTION__SET_VALID(_BINARY_FREGF__NEGF_FREGF_, _Binary_fRegF__NegF_fRegF__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGF_FREGF_) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[_NEGF_FREGF_]+_kids[1]->_cost[FREGF];
        DFA_PRODUCTION__SET_VALID(_BINARY__NEGF_FREGF__FREGF, _Binary__NegF_fRegF__fRegF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD];
        DFA_PRODUCTION__SET_VALID(_BINARY_FREGD_FREGD, _Binary_fRegD_fRegD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF];
        DFA_PRODUCTION__SET_VALID(_BINARY_FREGF_FREGF, _Binary_fRegF_fRegF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+_kids[1]->_cost[IREGN];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGN_IREGN, _Binary_iRegN_iRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI_R12) && STATE__VALID_CHILD(_kids[1], IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[IREGI_R12]+_kids[1]->_cost[IREGI_R13];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGI_R12_IREGI_R13, _Binary_iRegI_R12_iRegI_R13_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGI_IREGI, _Binary_iRegI_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGL_IREGL, _Binary_iRegL_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGP_IREGP, _Binary_iRegP_iRegP_rule, c)
    }
}
void  State::_sub_Op_Bool(const Node *n){
    if(         
#line 3441 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->as_Bool()->_test._test == BoolTest::ne ||
            n->as_Bool()->_test._test == BoolTest::eq ||
            n->as_Bool()->_test._test == BoolTest::le ||
            n->as_Bool()->_test._test == BoolTest::gt
#line 1345 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPUEQNELEGT, cmpOpUEqNeLeGt_rule, c)
    }
    if(         
#line 3421 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->as_Bool()->_test._test == BoolTest::lt ||
            n->as_Bool()->_test._test == BoolTest::ge
#line 1354 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPULTGE, cmpOpULtGe_rule, c)
    }
    if(         
#line 3401 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->as_Bool()->_test._test == BoolTest::ne ||
            n->as_Bool()->_test._test == BoolTest::eq
#line 1363 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPEQNE, cmpOpEqNe_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION__SET_VALID(CMPOPU, cmpOpU_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION__SET_VALID(CMPOP, cmpOp_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 105 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 1382 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+ALU_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, bytes_reverse_int_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, bytes_reverse_int_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, bytes_reverse_int_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, bytes_reverse_int_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, bytes_reverse_int_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, bytes_reverse_int_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+ALU_COST * 13;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, bytes_reverse_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, bytes_reverse_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, bytes_reverse_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, bytes_reverse_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, bytes_reverse_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, bytes_reverse_int_rule, c)
      }
    }
}
void  State::_sub_Op_ReverseBytesL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) &&
        (
#line 119 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 1435 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, bytes_reverse_long_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, bytes_reverse_long_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, bytes_reverse_long_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, bytes_reverse_long_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, bytes_reverse_long_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, bytes_reverse_long_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+ALU_COST * 29;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, bytes_reverse_long_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, bytes_reverse_long_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, bytes_reverse_long_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, bytes_reverse_long_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, bytes_reverse_long_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, bytes_reverse_long_rule, c)
      }
    }
}
void  State::_sub_Op_ReverseBytesUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 133 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 1484 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+ALU_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, bytes_reverse_unsigned_short_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, bytes_reverse_unsigned_short_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, bytes_reverse_unsigned_short_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, bytes_reverse_unsigned_short_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, bytes_reverse_unsigned_short_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, bytes_reverse_unsigned_short_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+ALU_COST * 5;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, bytes_reverse_unsigned_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, bytes_reverse_unsigned_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, bytes_reverse_unsigned_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, bytes_reverse_unsigned_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, bytes_reverse_unsigned_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, bytes_reverse_unsigned_short_rule, c)
      }
    }
}
void  State::_sub_Op_ReverseBytesS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 147 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 1537 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+ALU_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, bytes_reverse_short_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, bytes_reverse_short_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, bytes_reverse_short_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, bytes_reverse_short_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, bytes_reverse_short_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, bytes_reverse_short_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+ALU_COST * 5;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, bytes_reverse_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, bytes_reverse_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, bytes_reverse_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, bytes_reverse_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, bytes_reverse_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, bytes_reverse_short_rule, c)
      }
    }
}
void  State::_sub_Op_CallDynamicJava(const Node *n){
    {
      unsigned int c = BRANCH_COST + ALU_COST * 6;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallDynamicJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeaf(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeafNoFP(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafNoFPDirect_rule, c)
    }
}
void  State::_sub_Op_CallRuntime(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallRuntimeDirect_rule, c)
    }
}
void  State::_sub_Op_CallStaticJava(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallStaticJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CastII(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI];
        DFA_PRODUCTION__SET_VALID(IREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
    }
}
void  State::_sub_Op_CastX2P(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R11, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R12, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R13, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R14, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R15, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R16, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R28, castX2P_rule, c)
    }
}
void  State::_sub_Op_CastP2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_];
        DFA_PRODUCTION__SET_VALID(_CASTP2X__DECODEN_IREGN__, _CastP2X__DecodeN_iRegN___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, castP2X_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP];
        DFA_PRODUCTION__SET_VALID(_CASTP2X_IREGP_, _CastP2X_iRegP__rule, c)
    }
}
void  State::_sub_Op_CastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGPNOSP) ) {
      unsigned int c = _kids[0]->_cost[IREGPNOSP];
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R11, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R12, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R13, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R14, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R15, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R16, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R28, castPP_rule, c)
    }
}
void  State::_sub_Op_CheckCastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGPNOSP) ) {
      unsigned int c = _kids[0]->_cost[IREGPNOSP];
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R11, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R12, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R13, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R14, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R15, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R16, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R28, checkCastPP_rule, c)
    }
}
void  State::_sub_Op_ClearArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML) && STATE__VALID_CHILD(_kids[1], IREGP_R28) &&
        (
#line 10003 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
(uint64_t)n->in(2)->get_long() < (uint64_t)(BlockZeroingLowLimit >> LogBytesPerWord)
#line 1717 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+_kids[1]->_cost[IREGP_R28]+4 * DEFAULT_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, clearArray_imm_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL_R29) && STATE__VALID_CHILD(_kids[1], IREGP_R28) ) {
      unsigned int c = _kids[0]->_cost[IREGL_R29]+_kids[1]->_cost[IREGP_R28]+4 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, clearArray_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPUL_IREGL_IREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGINOSP_IREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPUL_IREGL_IREGL]+_kids[1]->_cost[_BINARY_IREGINOSP_IREGI]+ALU_COST + BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmovI_cmpUL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, cmovI_cmpUL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, cmovI_cmpUL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, cmovI_cmpUL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, cmovI_cmpUL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, cmovI_cmpUL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPL_IREGL_IREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGINOSP_IREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPL_IREGL_IREGL]+_kids[1]->_cost[_BINARY_IREGINOSP_IREGI]+ALU_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmovI_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, cmovI_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, cmovI_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, cmovI_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, cmovI_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, cmovI_cmpL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPU_IREGI_IREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGINOSP_IREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPU_IREGI_IREGI]+_kids[1]->_cost[_BINARY_IREGINOSP_IREGI]+ALU_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmovI_cmpU_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, cmovI_cmpU_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, cmovI_cmpU_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, cmovI_cmpU_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, cmovI_cmpU_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, cmovI_cmpU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_IREGI_IREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGINOSP_IREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_IREGI_IREGI]+_kids[1]->_cost[_BINARY_IREGINOSP_IREGI]+ALU_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmovI_cmpI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, cmovI_cmpI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, cmovI_cmpI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, cmovI_cmpI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, cmovI_cmpI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, cmovI_cmpI_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPU_IREGI_IREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGLNOSP_IREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPU_IREGI_IREGI]+_kids[1]->_cost[_BINARY_IREGLNOSP_IREGL]+ALU_COST + BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, cmovL_cmpU_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, cmovL_cmpU_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, cmovL_cmpU_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, cmovL_cmpU_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, cmovL_cmpU_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, cmovL_cmpU_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_IREGI_IREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGLNOSP_IREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_IREGI_IREGI]+_kids[1]->_cost[_BINARY_IREGLNOSP_IREGL]+ALU_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, cmovL_cmpI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, cmovL_cmpI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, cmovL_cmpI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, cmovL_cmpI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, cmovL_cmpI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, cmovL_cmpI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPUL_IREGL_IREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGLNOSP_IREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPUL_IREGL_IREGL]+_kids[1]->_cost[_BINARY_IREGLNOSP_IREGL]+ALU_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, cmovL_cmpUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, cmovL_cmpUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, cmovL_cmpUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, cmovL_cmpUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, cmovL_cmpUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, cmovL_cmpUL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPL_IREGL_IREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGLNOSP_IREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPL_IREGL_IREGL]+_kids[1]->_cost[_BINARY_IREGLNOSP_IREGL]+ALU_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, cmovL_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, cmovL_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, cmovL_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, cmovL_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, cmovL_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, cmovL_cmpL_rule, c)
      }
    }
}
void  State::_sub_Op_CmpN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGN) && STATE__VALID_CHILD(_kids[1], IMMN0) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+_kids[1]->_cost[IMMN0];
        DFA_PRODUCTION__SET_VALID(_CMPN_IREGN_IMMN0, _CmpN_iRegN_immN0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+_kids[1]->_cost[IREGN];
        DFA_PRODUCTION__SET_VALID(_CMPN_IREGN_IREGN, _CmpN_iRegN_iRegN_rule, c)
    }
}
void  State::_sub_Op_CmpD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD];
        DFA_PRODUCTION__SET_VALID(_CMPD_FREGD_FREGD, _CmpD_fRegD_fRegD_rule, c)
    }
}
void  State::_sub_Op_CmpD3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD]+XFER_COST * 2 + BRANCH_COST + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, cmpD3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF];
        DFA_PRODUCTION__SET_VALID(_CMPF_FREGF_FREGF, _CmpF_fRegF_fRegF_rule, c)
    }
}
void  State::_sub_Op_CmpF3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF]+XFER_COST * 2 + BRANCH_COST + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, cmpF3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI0];
        DFA_PRODUCTION__SET_VALID(_CMPI_IREGI_IMMI0, _CmpI_iRegI_immI0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION__SET_VALID(_CMPI_IREGI_IREGI, _CmpI_iRegI_iRegI_rule, c)
    }
}
void  State::_sub_Op_CmpL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML0];
        DFA_PRODUCTION__SET_VALID(_CMPL_IREGL_IMML0, _CmpL_iRegL_immL0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(_CMPL_IREGL_IREGL, _CmpL_iRegL_iRegL_rule, c)
    }
}
void  State::_sub_Op_CmpL3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL]+ALU_COST * 3 + BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, cmpL3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpLTMask(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI0] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, cmpLTMask_reg_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+2 * ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, cmpLTMask_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _PARTIALSUBTYPECHECK_IREGP_R14_IREGP_R10) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_PARTIALSUBTYPECHECK_IREGP_R14_IREGP_R10]+_kids[1]->_cost[IMMP0]+2 * STORE_COST + 3 * LOAD_COST + 4 * ALU_COST + BRANCH_COST * 4;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, partialSubtypeCheckVsZero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[IMMP0];
        DFA_PRODUCTION__SET_VALID(_CMPP__DECODEN_IREGN__IMMP0, _CmpP__DecodeN_iRegN__immP0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMP0];
        DFA_PRODUCTION__SET_VALID(_CMPP_IREGP_IMMP0, _CmpP_iRegP_immP0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP];
        DFA_PRODUCTION__SET_VALID(_CMPP_IREGP_IREGP, _CmpP_iRegP_iRegP_rule, c)
    }
}
void  State::_sub_Op_CmpU(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI0];
        DFA_PRODUCTION__SET_VALID(_CMPU_IREGI_IMMI0, _CmpU_iRegI_immI0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION__SET_VALID(_CMPU_IREGI_IREGI, _CmpU_iRegI_iRegI_rule, c)
    }
}
void  State::_sub_Op_CmpUL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML0];
        DFA_PRODUCTION__SET_VALID(_CMPUL_IREGL_IMML0, _CmpUL_iRegL_immL0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(_CMPUL_IREGL_IREGL, _CmpUL_iRegL_iRegL_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) &&
        (
#line 5071 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2125 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + ALU_COST * 10 + BRANCH_COST * 4;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapBAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapBAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndSwapBAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndSwapBAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndSwapBAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndSwapBAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + ALU_COST * 10 + BRANCH_COST * 4;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndSwapB_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) &&
        (
#line 5096 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2178 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + ALU_COST * 11 + BRANCH_COST * 4;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapSAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapSAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndSwapSAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndSwapSAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndSwapSAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndSwapSAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + ALU_COST * 11 + BRANCH_COST * 4;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndSwapS_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IREGI) &&
        (
#line 5120 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2231 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_IREGI]+LOAD_COST + STORE_COST + ALU_COST * 6 + BRANCH_COST * 4;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndSwapIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndSwapIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndSwapIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndSwapIAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_IREGI]+LOAD_COST + STORE_COST + ALU_COST * 6 + BRANCH_COST * 4;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndSwapI_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) &&
        (
#line 5138 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2284 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+LOAD_COST + STORE_COST + ALU_COST * 6 + BRANCH_COST * 4;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndSwapLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndSwapLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndSwapLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndSwapLAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+LOAD_COST + STORE_COST + ALU_COST * 6 + BRANCH_COST * 4;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndSwapL_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 5156 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2337 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+LOAD_COST + STORE_COST + ALU_COST * 6 + BRANCH_COST * 4;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndSwapPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndSwapPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndSwapPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndSwapPAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+LOAD_COST + STORE_COST + ALU_COST * 6 + BRANCH_COST * 4;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndSwapP_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) &&
        (
#line 5174 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2390 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+LOAD_COST + STORE_COST + ALU_COST * 8 + BRANCH_COST * 4;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndSwapNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndSwapNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndSwapNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndSwapNAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+LOAD_COST + STORE_COST + ALU_COST * 8 + BRANCH_COST * 4;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndSwapN_rule, c)
      }
    }
}
void  State::_sub_Op_WeakCompareAndSwapB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) &&
        (
#line 5587 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2443 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 6;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, weakCompareAndSwapBAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, weakCompareAndSwapBAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, weakCompareAndSwapBAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, weakCompareAndSwapBAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, weakCompareAndSwapBAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, weakCompareAndSwapBAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 6;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, weakCompareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, weakCompareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, weakCompareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, weakCompareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, weakCompareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, weakCompareAndSwapB_rule, c)
      }
    }
}
void  State::_sub_Op_WeakCompareAndSwapS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) &&
        (
#line 5613 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2496 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 7;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, weakCompareAndSwapSAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, weakCompareAndSwapSAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, weakCompareAndSwapSAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, weakCompareAndSwapSAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, weakCompareAndSwapSAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, weakCompareAndSwapSAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 7;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, weakCompareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, weakCompareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, weakCompareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, weakCompareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, weakCompareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, weakCompareAndSwapS_rule, c)
      }
    }
}
void  State::_sub_Op_WeakCompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IREGI) &&
        (
#line 5638 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2549 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_IREGI]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, weakCompareAndSwapIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, weakCompareAndSwapIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, weakCompareAndSwapIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, weakCompareAndSwapIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, weakCompareAndSwapIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, weakCompareAndSwapIAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_IREGI]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, weakCompareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, weakCompareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, weakCompareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, weakCompareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, weakCompareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, weakCompareAndSwapI_rule, c)
      }
    }
}
void  State::_sub_Op_WeakCompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) &&
        (
#line 5660 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2602 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, weakCompareAndSwapLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, weakCompareAndSwapLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, weakCompareAndSwapLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, weakCompareAndSwapLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, weakCompareAndSwapLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, weakCompareAndSwapLAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, weakCompareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, weakCompareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, weakCompareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, weakCompareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, weakCompareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, weakCompareAndSwapL_rule, c)
      }
    }
}
void  State::_sub_Op_WeakCompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 5704 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2655 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, weakCompareAndSwapPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, weakCompareAndSwapPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, weakCompareAndSwapPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, weakCompareAndSwapPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, weakCompareAndSwapPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, weakCompareAndSwapPAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, weakCompareAndSwapP_rule, c)
      }
    }
}
void  State::_sub_Op_WeakCompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) &&
        (
#line 5682 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2708 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 4;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, weakCompareAndSwapNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, weakCompareAndSwapNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, weakCompareAndSwapNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, weakCompareAndSwapNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, weakCompareAndSwapNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, weakCompareAndSwapNAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 4;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, weakCompareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, weakCompareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, weakCompareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, weakCompareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, weakCompareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, weakCompareAndSwapN_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndExchangeB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) &&
        (
#line 5323 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2761 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST * 5;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndExchangeBAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndExchangeBAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndExchangeBAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndExchangeBAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndExchangeBAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndExchangeBAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST * 5;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndExchangeB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndExchangeB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndExchangeB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndExchangeB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndExchangeB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndExchangeB_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndExchangeS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) &&
        (
#line 5347 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2814 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST * 6;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndExchangeSAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndExchangeSAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndExchangeSAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndExchangeSAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndExchangeSAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndExchangeSAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST * 6;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndExchangeS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndExchangeS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndExchangeS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndExchangeS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndExchangeS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndExchangeS_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndExchangeI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IREGI) &&
        (
#line 5370 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2867 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_IREGI]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndExchangeIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndExchangeIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndExchangeIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndExchangeIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndExchangeIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndExchangeIAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_IREGI]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndExchangeI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndExchangeI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, compareAndExchangeI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, compareAndExchangeI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, compareAndExchangeI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, compareAndExchangeI_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndExchangeL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) &&
        (
#line 5392 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2920 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, compareAndExchangeLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, compareAndExchangeLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, compareAndExchangeLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, compareAndExchangeLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, compareAndExchangeLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, compareAndExchangeLAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, compareAndExchangeL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, compareAndExchangeL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, compareAndExchangeL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, compareAndExchangeL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, compareAndExchangeL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, compareAndExchangeL_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndExchangeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 5436 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2969 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, compareAndExchangePAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, compareAndExchangePAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, compareAndExchangePAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, compareAndExchangePAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, compareAndExchangePAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, compareAndExchangePAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R11, compareAndExchangePAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R12, compareAndExchangePAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R13, compareAndExchangePAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R14, compareAndExchangePAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R15, compareAndExchangePAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R16, compareAndExchangePAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R28, compareAndExchangePAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R11, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R12, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R13, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R14, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R15, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R16, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R28, compareAndExchangeP_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndExchangeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) &&
        (
#line 5414 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3050 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, compareAndExchangeNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGN, compareAndExchangeNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegN_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST * 3;
      if (STATE__NOT_YET_VALID(IREGNNOSP) || _cost[IREGNNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, compareAndExchangeN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegNNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION__SET_VALID(IREGN, compareAndExchangeN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegN_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndAddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMIADD) &&
        (
#line 6100 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used() && needs_acquiring_load_reserved(n)
#line 3083 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMIADD] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addIi_no_resAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMIADD) &&
        (
#line 6083 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3092 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMIADD] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_addIiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_addIiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, get_and_addIiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, get_and_addIiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, get_and_addIiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, get_and_addIiAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) &&
        (
#line 6066 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used() && needs_acquiring_load_reserved(n)
#line 3110 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addI_no_resAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) &&
        (
#line 6049 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3121 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_addIAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_addIAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, get_and_addIAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, get_and_addIAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, get_and_addIAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, get_and_addIAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMIADD) &&
        (
#line 5965 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used()
#line 3159 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMIADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addIi_no_res_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMIADD) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMIADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_addIi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_addIi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, get_and_addIi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, get_and_addIi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, get_and_addIi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, get_and_addIi_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) &&
        (
#line 5933 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used()
#line 3203 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addI_no_res_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_addI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_addI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, get_and_addI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, get_and_addI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, get_and_addI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, get_and_addI_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndAddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMLADD) &&
        (
#line 6032 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used() && needs_acquiring_load_reserved(n)
#line 3249 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMLADD] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addLi_no_resAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMLADD) &&
        (
#line 6015 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3258 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMLADD] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, get_and_addLiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, get_and_addLiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, get_and_addLiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, get_and_addLiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, get_and_addLiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, get_and_addLiAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 5998 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used() && needs_acquiring_load_reserved(n)
#line 3275 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addL_no_resAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 5982 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3286 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, get_and_addLAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, get_and_addLAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, get_and_addLAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, get_and_addLAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, get_and_addLAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, get_and_addLAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMLADD) &&
        (
#line 5901 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used()
#line 3321 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMLADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addLi_no_res_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMLADD) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMLADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, get_and_addLi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, get_and_addLi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, get_and_addLi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, get_and_addLi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, get_and_addLi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, get_and_addLi_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 5869 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used()
#line 3362 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addL_no_res_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, get_and_addL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, get_and_addL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, get_and_addL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, get_and_addL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, get_and_addL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, get_and_addL_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndSetI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 5786 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3405 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGI] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_setIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_setIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, get_and_setIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, get_and_setIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, get_and_setIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, get_and_setIAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_setI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_setI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, get_and_setI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, get_and_setI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, get_and_setI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, get_and_setI_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndSetL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 5803 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3458 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, get_and_setLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, get_and_setLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, get_and_setLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, get_and_setLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, get_and_setLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, get_and_setLAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, get_and_setL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, get_and_setL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, get_and_setL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, get_and_setL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, get_and_setL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, get_and_setL_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndSetP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGP) &&
        (
#line 5837 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3507 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGP] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R11, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R12, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R13, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R14, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R15, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R16, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R28, get_and_setPAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGP] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R11, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R12, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R13, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R14, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R15, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R16, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R28, get_and_setP_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndSetN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGN) &&
        (
#line 5820 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3588 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGN] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_setNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_setNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, get_and_setNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, get_and_setNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, get_and_setNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, get_and_setNAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGN] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_setN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_setN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, get_and_setN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, get_and_setN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, get_and_setN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, get_and_setN_rule, c)
      }
    }
}
void  State::_sub_Op_ConN(const Node *n){
    if(         
#line 2762 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->get_narrowcon() == 0
#line 3640 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMN0, immN0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, loadConN0_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGN, loadConN0_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegN_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegN_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegNNoSp_rule, c+ALU_COST)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMN, immN_rule, c)
      if (STATE__NOT_YET_VALID(IREGNNOSP) || _cost[IREGNNOSP] > c+ALU_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, loadConN_rule, c+ALU_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c+ALU_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGN, loadConN_rule, c+ALU_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c+ALU_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegN_rule, c+ALU_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c+ALU_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegN_rule, c+ALU_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c+ALU_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegNNoSp_rule, c+ALU_COST * 4)
      }
    }
   if ( /* IREGNNOSP KNOWN_VALID || */ _cost[IREGNNOSP] > ALU_COST * 4) {
     DFA_PRODUCTION(IREGNNOSP, loadConN_rule, ALU_COST * 4)
   }
   if ( /* IREGN KNOWN_VALID || */ _cost[IREGN] > ALU_COST * 4) {
     DFA_PRODUCTION(IREGN, loadConN_rule, ALU_COST * 4)
   }
   if ( /* IREGNORP KNOWN_VALID || */ _cost[IREGNORP] > ALU_COST * 4) {
     DFA_PRODUCTION(IREGNORP, iRegN_rule, ALU_COST * 4)
   }
   if ( /* IREGILNP KNOWN_VALID || */ _cost[IREGILNP] > ALU_COST * 4) {
     DFA_PRODUCTION(IREGILNP, iRegN_rule, ALU_COST * 4)
   }
   if ( /* IREGILNPNOSP KNOWN_VALID || */ _cost[IREGILNPNOSP] > ALU_COST * 4) {
     DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, ALU_COST * 4)
   }
}
void  State::_sub_Op_ConNKlass(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMNKLASS, immNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, loadConNKlass_rule, c+ALU_COST * 6)
        DFA_PRODUCTION__SET_VALID(IREGN, loadConNKlass_rule, c+ALU_COST * 6)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegN_rule, c+ALU_COST * 6)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegN_rule, c+ALU_COST * 6)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegNNoSp_rule, c+ALU_COST * 6)
    }
   if ( /* IREGNNOSP KNOWN_VALID || */ _cost[IREGNNOSP] > ALU_COST * 6) {
     DFA_PRODUCTION(IREGNNOSP, loadConNKlass_rule, ALU_COST * 6)
   }
   if ( /* IREGN KNOWN_VALID || */ _cost[IREGN] > ALU_COST * 6) {
     DFA_PRODUCTION(IREGN, loadConNKlass_rule, ALU_COST * 6)
   }
   if ( /* IREGNORP KNOWN_VALID || */ _cost[IREGNORP] > ALU_COST * 6) {
     DFA_PRODUCTION(IREGNORP, iRegN_rule, ALU_COST * 6)
   }
   if ( /* IREGILNP KNOWN_VALID || */ _cost[IREGILNP] > ALU_COST * 6) {
     DFA_PRODUCTION(IREGILNP, iRegN_rule, ALU_COST * 6)
   }
   if ( /* IREGILNPNOSP KNOWN_VALID || */ _cost[IREGILNPNOSP] > ALU_COST * 6) {
     DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, ALU_COST * 6)
   }
}
void  State::_sub_Op_ConD(const Node *n){
    if(         
#line 2792 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
jlong_cast(n->getd()) == 0
#line 3715 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMD0, immD0_rule, c)
        DFA_PRODUCTION__SET_VALID(FREGD, loadConD0_rule, c+XFER_COST)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMD, immD_rule, c)
      if (STATE__NOT_YET_VALID(FREGD) || _cost[FREGD] > c+LOAD_COST) {
        DFA_PRODUCTION__SET_VALID(FREGD, loadConD_rule, c+LOAD_COST)
      }
    }
}
void  State::_sub_Op_ConF(const Node *n){
    if(         
#line 2812 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
jint_cast(n->getf()) == 0
#line 3733 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMF0, immF0_rule, c)
        DFA_PRODUCTION__SET_VALID(FREGF, loadConF0_rule, c+XFER_COST)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMF, immF_rule, c)
      if (STATE__NOT_YET_VALID(FREGF) || _cost[FREGF] > c+LOAD_COST) {
        DFA_PRODUCTION__SET_VALID(FREGF, loadConF_rule, c+LOAD_COST)
      }
    }
}
void  State::_sub_Op_ConI(const Node *n){
    int _n_get_int__ = n->get_int();
    if(         
#line 2841 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
1 <= _n_get_int__ && (_n_get_int__ <= 3)
#line 3752 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMISCALE, immIScale_rule, c)
    }
    if(         
#line 2822 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
is_imm_in_range(_n_get_int__, 12, 0)
#line 3760 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMIOFFSET, immIOffset_rule, c)
    }
    if(         
#line 2686 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
is_power_of_2((juint)(_n_get_int__))
#line 3768 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMIPOWEROF2, immIpowerOf2_rule, c)
    }
    if(         
#line 2678 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == 0xFFFF
#line 3776 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_16BITS, immI_16bits_rule, c)
    }
    if(         
#line 2576 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ <= 15 && _n_get_int__ >= -16
#line 3784 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI5, immI5_rule, c)
    }
    if(         
#line 2566 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
Assembler::operand_valid_for_add_immediate(-(int64_t)n->get_int())
#line 3792 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMISUB, immISub_rule, c)
    }
    if(         
#line 2556 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
Assembler::operand_valid_for_add_immediate((int64_t)n->get_int())
#line 3800 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMIADD, immIAdd_rule, c)
    }
    if(         
#line 2545 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == 63
#line 3808 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_63, immI_63_rule, c)
    }
    if(         
#line 2535 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == 31
#line 3816 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_31, immI_31_rule, c)
    }
    if(         
#line 2526 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == 24
#line 3824 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_24, immI_24_rule, c)
    }
    if(         
#line 2517 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == 16
#line 3832 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_16, immI_16_rule, c)
    }
    if(         
#line 2507 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ <= 4
#line 3840 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_LE_4, immI_le_4_rule, c)
    }
    if(         
#line 2498 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
((unsigned int)(_n_get_int__) < 64) && (_n_get_int__ >= 32)
#line 3848 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UIMMI6_GE32, uimmI6_ge32_rule, c)
    }
    if(         
#line 2488 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == -1
#line 3856 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_M1, immI_M1_rule, c)
    }
    if(         
#line 2477 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == 1
#line 3864 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_1, immI_1_rule, c)
    }
    if(         
#line 2466 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == 0
#line 3872 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI0, immI0_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI, immI_rule, c)
        DFA_PRODUCTION__SET_VALID(IMMIORL, immI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadConI_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGI, loadConI_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, loadConI_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, loadConI_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, loadConI_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, loadConI_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c+ALU_COST)
    }
}
void  State::_sub_Op_ConL(const Node *n){
    jlong _n_get_long__ = n->get_long();
    if(         
#line 2831 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
is_imm_in_range(_n_get_long__, 12, 0)
#line 3898 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMLOFFSET, immLOffset_rule, c)
    }
    if(         
#line 2741 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
Assembler::operand_valid_for_add_immediate(-(_n_get_long__))
#line 3906 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMLSUB, immLSub_rule, c)
    }
    if(         
#line 2731 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
Assembler::operand_valid_for_add_immediate(_n_get_long__)
#line 3914 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMLADD, immLAdd_rule, c)
    }
    if(         
#line 2719 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
_n_get_long__ == in_bytes(JavaThread::frame_anchor_offset()) +
                             in_bytes(JavaFrameAnchor::last_Java_pc_offset())
#line 3923 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_PC_OFF, immL_pc_off_rule, c)
    }
    if(         
#line 2706 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
_n_get_long__ == -1
#line 3931 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_M1, immL_M1_rule, c)
    }
    if(         
#line 2696 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
_n_get_long__ == 0xFFFFFFFFL
#line 3939 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_32BITS, immL_32bits_rule, c)
    }
    if(         
#line 2609 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
_n_get_long__ == 0
#line 3947 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML0, immL0_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML, immL_rule, c)
        DFA_PRODUCTION__SET_VALID(IMMIORL, immL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadConL_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGL, loadConL_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, loadConL_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, loadConL_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, loadConL_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, loadConL_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c+ALU_COST)
    }
    if(         
#line 2587 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
_n_get_long__ <= 15 && _n_get_long__ >= -16
#line 3969 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML5, immL5_rule, c)
    }
}
void  State::_sub_Op_ConP(const Node *n){
    if(         
#line 2666 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
BarrierSet::barrier_set()->is_a(BarrierSet::CardTableBarrierSet) &&
            (jbyte*)n->get_ptr() == ((CardTableBarrierSet*)(BarrierSet::barrier_set()))->card_table()->byte_map_base()
#line 3980 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMBYTEMAPBASE, immByteMapBase_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGP, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGP_R11, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGP_R12, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGP_R13, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGP_R14, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGP_R15, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGP_R16, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGP_R28, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c+ALU_COST)
    }
    if(         
#line 2654 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
(address)n->get_ptr() == os::get_polling_page()
#line 4005 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMPOLLPAGE, immPollPage_rule, c)
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadConPollPage_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(IREGP, loadConPollPage_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, loadConPollPage_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConPollPage_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadConPollPage_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadConPollPage_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(IREGP_R11, loadConPollPage_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(IREGP_R12, loadConPollPage_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(IREGP_R13, loadConPollPage_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(IREGP_R14, loadConPollPage_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(IREGP_R15, loadConPollPage_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(IREGP_R16, loadConPollPage_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(IREGP_R28, loadConPollPage_rule, c+ALU_COST * 6)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c+ALU_COST * 6) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c+ALU_COST * 6)
      }
    }
    if(         
#line 2643 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->get_ptr() == 1
#line 4064 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMP_1, immP_1_rule, c)
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R11, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R12, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R13, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R14, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R15, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R16, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R28, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c+ALU_COST)
      }
    }
    if(         
#line 2631 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->get_ptr() == 0
#line 4123 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMP0, immP0_rule, c)
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R11, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R12, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R13, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R14, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R15, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R16, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R28, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c+ALU_COST)
      }
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMP, immP_rule, c)
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R11, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R12, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R13, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R14, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R15, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R16, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R28, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c+ALU_COST) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c+ALU_COST)
      }
    }
}
void  State::_sub_Op_Conv2B(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _ANDI_IREGIORL2I_IMMIPOWEROF2) &&
        (
#line 456 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbs
#line 4240 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_IREGIORL2I_IMMIPOWEROF2] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convI2Bool_andI_reg_immIpowerOf2_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, convI2Bool_andI_reg_immIpowerOf2_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, convI2Bool_andI_reg_immIpowerOf2_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, convI2Bool_andI_reg_immIpowerOf2_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, convI2Bool_andI_reg_immIpowerOf2_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, convI2Bool_andI_reg_immIpowerOf2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convP2Bool_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, convP2Bool_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, convP2Bool_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, convP2Bool_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, convP2Bool_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, convP2Bool_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convI2Bool_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, convI2Bool_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, convI2Bool_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, convI2Bool_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, convI2Bool_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, convI2Bool_rule, c)
      }
    }
}
void  State::_sub_Op_ConvD2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(FREGF, convD2F_reg_rule, c)
    }
}
void  State::_sub_Op_ConvD2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, convD2I_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, convD2L_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvF2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(FREGD, convF2D_reg_rule, c)
    }
}
void  State::_sub_Op_ConvF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, convF2I_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvF2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, convF2L_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvI2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(FREGD, convI2D_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(FREGF, convI2F_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvI2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_IREGIORL2I_, _ConvI2L_iRegIorL2I__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, convI2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_IREGI_, _ConvI2L_iRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_CONVI2L__LOADI_MEMORY__, _ConvI2L__LoadI_memory___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, loadI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, loadUS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, loadS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, loadUB2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, loadB2L_rule, c)
      }
    }
}
void  State::_sub_Op_ConvL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(FREGD, convL2D_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvL2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(FREGF, convL2F_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvL2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_IREGP_) &&
        (
#line 30 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 4596 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_IREGP_] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convP2I_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, convP2I_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, convP2I_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, convP2I_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, convP2I_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, convP2I_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X__DECODEN_IREGN__) &&
        (
#line 7856 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
Universe::narrow_oop_shift() == 0
#line 4614 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X__DECODEN_IREGN__] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, convN2I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_IREGP_) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_IREGP_]+ALU_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, convP2I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convL2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, convL2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, convL2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, convL2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, convL2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, convL2I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(_CONVL2I_IREGL_, _ConvL2I_iRegL__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(IREGL2I, iRegL2I_rule, c)
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegL2I_rule, c)
      }
    }
}
void  State::_sub_Op_CountedLoopEnd(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], _CMPP__DECODEN_IREGN__IMMP0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[_CMPP__DECODEN_IREGN__IMMP0]+BRANCH_COST * 2;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpP_narrowOop_imm0_loop_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], _CMPN_IREGN_IMMN0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[_CMPN_IREGN_IMMN0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpN_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], _CMPP_IREGP_IMMP0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[_CMPP_IREGP_IMMP0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpP_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPULTGE) && STATE__VALID_CHILD(_kids[1], _CMPUL_IREGL_IMML0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPULTGE]+_kids[1]->_cost[_CMPUL_IREGL_IMML0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpULLtGe_reg_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUEQNELEGT) && STATE__VALID_CHILD(_kids[1], _CMPUL_IREGL_IMML0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUEQNELEGT]+_kids[1]->_cost[_CMPUL_IREGL_IMML0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpULEqNeLeGt_reg_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_IREGL_IMML0) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_IREGL_IMML0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpL_reg_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPULTGE) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPULTGE]+_kids[1]->_cost[_CMPU_IREGI_IMMI0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpULtGe_reg_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUEQNELEGT) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUEQNELEGT]+_kids[1]->_cost[_CMPU_IREGI_IMMI0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpUEqNeLeGt_reg_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGI_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_IREGI_IMMI0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpI_reg_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPD_FREGD_FREGD) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPD_FREGD_FREGD]+XFER_COST + BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpD_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPF_FREGF_FREGF) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPF_FREGF_FREGF]+XFER_COST + BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpF_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPN_IREGN_IREGN) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPN_IREGN_IREGN]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpN_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPP_IREGP_IREGP) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPP_IREGP_IREGP]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpP_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPUL_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPUL_IREGL_IREGL]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpUL_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_IREGL_IREGL]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpLloop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPU_IREGI_IREGI]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpU_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_IREGI_IREGI]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpI_loop_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 236 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 4833 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, countLeadingZerosI_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, countLeadingZerosI_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, countLeadingZerosI_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, countLeadingZerosI_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, countLeadingZerosI_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, countLeadingZerosI_b_rule, c)
    }
}
void  State::_sub_Op_CountLeadingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) &&
        (
#line 250 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 4853 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, countLeadingZerosL_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, countLeadingZerosL_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, countLeadingZerosL_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, countLeadingZerosL_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, countLeadingZerosL_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, countLeadingZerosL_b_rule, c)
    }
}
void  State::_sub_Op_CountTrailingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 264 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 4873 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, countTrailingZerosI_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, countTrailingZerosI_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, countTrailingZerosI_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, countTrailingZerosI_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, countTrailingZerosI_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, countTrailingZerosI_b_rule, c)
    }
}
void  State::_sub_Op_CountTrailingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) &&
        (
#line 278 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 4893 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, countTrailingZerosL_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, countTrailingZerosL_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, countTrailingZerosL_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, countTrailingZerosL_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, countTrailingZerosL_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, countTrailingZerosL_b_rule, c)
    }
}
void  State::_sub_Op_CreateEx(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R10, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
    }
}
void  State::_sub_Op_DecodeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGN) &&
        (
#line 7899 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->bottom_type()->is_ptr()->ptr() == TypePtr::NotNull ||
            n->bottom_type()->is_ptr()->ptr() == TypePtr::Constant
#line 4927 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGN];
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R11, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R12, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R13, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R14, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R15, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R16, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R28, decodeHeapOop_not_null_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) &&
        (
#line 7884 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
n->bottom_type()->is_ptr()->ptr() != TypePtr::NotNull &&
            n->bottom_type()->is_ptr()->ptr() != TypePtr::Constant
#line 4953 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGN];
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R11, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R12, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R13, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R14, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R15, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R16, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R28, decodeHeapOop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IREGN];
        DFA_PRODUCTION__SET_VALID(_DECODEN_IREGN_, _DecodeN_iRegN__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) &&
        
#line 3204 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
Universe::narrow_oop_shift() == 0
#line 5016 "dfa_riscv.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[IREGN];
        DFA_PRODUCTION__SET_VALID(INDIRECTN, indirectN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirectN_rule, c)
      }
    }
}
void  State::_sub_Op_DecodeNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IREGN] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R11, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R12, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R13, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R14, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R15, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R16, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R28, decodeKlass_not_null_rule, c)
    }
}
void  State::_sub_Op_DivD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD] + FDIV_COST;
        DFA_PRODUCTION__SET_VALID(FREGD, divD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_DivF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF] + FDIV_COST;
        DFA_PRODUCTION__SET_VALID(FREGF, divF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_DivI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + IDIVSI_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, divI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, divI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, divI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, divI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, divI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, divI_rule, c)
    }
}
void  State::_sub_Op_DivL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + IDIVDI_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, divL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, divL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, divL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, divL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, divL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, divL_rule, c)
    }
}
void  State::_sub_Op_EncodeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, encodeHeapOop_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGN, encodeHeapOop_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegN_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegN_rule, c)
    }
}
void  State::_sub_Op_EncodePKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegN_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegN_rule, c)
    }
}
void  State::_sub_Op_FastLock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP]+LOAD_COST * 2 + STORE_COST * 3 + ALU_COST * 6 + BRANCH_COST * 3;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, cmpFastLock_rule, c)
    }
}
void  State::_sub_Op_FastUnlock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP]+LOAD_COST * 2 + STORE_COST + ALU_COST * 2 + BRANCH_COST * 4;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, cmpFastUnlock_rule, c)
    }
}
void  State::_sub_Op_FmaD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _NEGD_FREGD_) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGD__NEGD_FREGD_) &&
        (
#line 6953 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5125 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGD_FREGD_]+_kids[1]->_cost[_BINARY_FREGD__NEGD_FREGD_] + FMUL_DOUBLE_COST;
        DFA_PRODUCTION__SET_VALID(FREGD, nmaddD_reg_reg_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGD_FREGD_) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGD_FREGD__FREGD) &&
        (
#line 6953 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5134 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGD_FREGD_]+_kids[1]->_cost[_BINARY__NEGD_FREGD__FREGD] + FMUL_DOUBLE_COST;
      if (STATE__NOT_YET_VALID(FREGD) || _cost[FREGD] > c) {
        DFA_PRODUCTION__SET_VALID(FREGD, nmaddD_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGD__NEGD_FREGD_) &&
        (
#line 6915 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5145 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[_BINARY_FREGD__NEGD_FREGD_] + FMUL_DOUBLE_COST;
      if (STATE__NOT_YET_VALID(FREGD) || _cost[FREGD] > c) {
        DFA_PRODUCTION__SET_VALID(FREGD, nmsubD_reg_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGD_FREGD__FREGD) &&
        (
#line 6915 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5156 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[_BINARY__NEGD_FREGD__FREGD] + FMUL_DOUBLE_COST;
      if (STATE__NOT_YET_VALID(FREGD) || _cost[FREGD] > c) {
        DFA_PRODUCTION__SET_VALID(FREGD, nmsubD_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGD_FREGD_) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGD_FREGD) &&
        (
#line 6878 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5167 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGD_FREGD_]+_kids[1]->_cost[_BINARY_FREGD_FREGD] + FMUL_DOUBLE_COST;
      if (STATE__NOT_YET_VALID(FREGD) || _cost[FREGD] > c) {
        DFA_PRODUCTION__SET_VALID(FREGD, msubD_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGD_FREGD) &&
        (
#line 6842 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5178 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[_BINARY_FREGD_FREGD] + FMUL_DOUBLE_COST;
      if (STATE__NOT_YET_VALID(FREGD) || _cost[FREGD] > c) {
        DFA_PRODUCTION__SET_VALID(FREGD, maddD_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_FmaF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _NEGF_FREGF_) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGF__NEGF_FREGF_) &&
        (
#line 6934 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5191 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGF_FREGF_]+_kids[1]->_cost[_BINARY_FREGF__NEGF_FREGF_] + FMUL_SINGLE_COST;
        DFA_PRODUCTION__SET_VALID(FREGF, nmaddF_reg_reg_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGF_FREGF_) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGF_FREGF__FREGF) &&
        (
#line 6934 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5200 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGF_FREGF_]+_kids[1]->_cost[_BINARY__NEGF_FREGF__FREGF] + FMUL_SINGLE_COST;
      if (STATE__NOT_YET_VALID(FREGF) || _cost[FREGF] > c) {
        DFA_PRODUCTION__SET_VALID(FREGF, nmaddF_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGF__NEGF_FREGF_) &&
        (
#line 6896 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5211 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[_BINARY_FREGF__NEGF_FREGF_] + FMUL_SINGLE_COST;
      if (STATE__NOT_YET_VALID(FREGF) || _cost[FREGF] > c) {
        DFA_PRODUCTION__SET_VALID(FREGF, nmsubF_reg_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGF_FREGF__FREGF) &&
        (
#line 6896 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5222 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[_BINARY__NEGF_FREGF__FREGF] + FMUL_SINGLE_COST;
      if (STATE__NOT_YET_VALID(FREGF) || _cost[FREGF] > c) {
        DFA_PRODUCTION__SET_VALID(FREGF, nmsubF_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGF_FREGF_) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGF_FREGF) &&
        (
#line 6860 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5233 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGF_FREGF_]+_kids[1]->_cost[_BINARY_FREGF_FREGF] + FMUL_SINGLE_COST;
      if (STATE__NOT_YET_VALID(FREGF) || _cost[FREGF] > c) {
        DFA_PRODUCTION__SET_VALID(FREGF, msubF_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGF_FREGF) &&
        (
#line 6824 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5244 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[_BINARY_FREGF_FREGF] + FMUL_SINGLE_COST;
      if (STATE__NOT_YET_VALID(FREGF) || _cost[FREGF] > c) {
        DFA_PRODUCTION__SET_VALID(FREGF, maddF_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_Goto(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branch_rule, c)
    }
}
void  State::_sub_Op_Halt(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, ShouldNotReachHere_rule, c)
    }
}
void  State::_sub_Op_If(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], _CMPP__DECODEN_IREGN__IMMP0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[_CMPP__DECODEN_IREGN__IMMP0]+BRANCH_COST * 2;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpP_narrowOop_imm0_branch_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], _CMPN_IREGN_IMMN0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[_CMPN_IREGN_IMMN0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpN_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], _CMPP_IREGP_IMMP0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[_CMPP_IREGP_IMMP0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpP_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPULTGE) && STATE__VALID_CHILD(_kids[1], _CMPUL_IREGL_IMML0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPULTGE]+_kids[1]->_cost[_CMPUL_IREGL_IMML0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpULLtGe_reg_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUEQNELEGT) && STATE__VALID_CHILD(_kids[1], _CMPUL_IREGL_IMML0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUEQNELEGT]+_kids[1]->_cost[_CMPUL_IREGL_IMML0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpULEqNeLeGt_reg_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_IREGL_IMML0) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_IREGL_IMML0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpL_reg_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPULTGE) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPULTGE]+_kids[1]->_cost[_CMPU_IREGI_IMMI0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpULtGe_reg_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUEQNELEGT) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUEQNELEGT]+_kids[1]->_cost[_CMPU_IREGI_IMMI0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpUEqNeLeGt_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGI_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_IREGI_IMMI0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpI_reg_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPD_FREGD_FREGD) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPD_FREGD_FREGD]+XFER_COST + BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpD_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPF_FREGF_FREGF) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPF_FREGF_FREGF]+XFER_COST + BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpF_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPN_IREGN_IREGN) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPN_IREGN_IREGN]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpN_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPP_IREGP_IREGP) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPP_IREGP_IREGP]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpP_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPUL_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPUL_IREGL_IREGL]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpUL_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_IREGL_IREGL]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpL_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPU_IREGI_IREGI]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpU_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_IREGI_IREGI]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpI_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], RFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[RFLAGSREG] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpFlag_branch_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_IREGIORL2I_IMMI_16, _LShiftI_iRegIorL2I_immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_IREGIORL2I_IMMI_24, _LShiftI_iRegIorL2I_immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, lShiftI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, lShiftI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, lShiftI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, lShiftI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, lShiftI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, lShiftI_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, lShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, lShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, lShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, lShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, lShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, lShiftI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGI_) && STATE__VALID_CHILD(_kids[1], IMMISCALE) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGI_]+_kids[1]->_cost[IMMISCALE];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL__CONVI2L_IREGI__IMMISCALE, _LShiftL__ConvI2L_iRegI__immIScale_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMISCALE) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMISCALE];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_IREGL_IMMISCALE, _LShiftL_iRegL_immIScale_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, lShiftL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, lShiftL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, lShiftL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, lShiftL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, lShiftL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, lShiftL_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, lShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, lShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, lShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, lShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, lShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, lShiftL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGI_) && STATE__VALID_CHILD(_kids[1], UIMMI6_GE32) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGI_]+_kids[1]->_cost[UIMMI6_GE32] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, lShiftL_regI_immGE32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, lShiftL_regI_immGE32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, lShiftL_regI_immGE32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, lShiftL_regI_immGE32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, lShiftL_regI_immGE32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, lShiftL_regI_immGE32_rule, c)
      }
    }
}
void  State::_sub_Op_LoadB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADB_MEMORY_, _LoadB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, loadB_rule, c)
    }
}
void  State::_sub_Op_LoadUB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUB_MEMORY_, _LoadUB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, loadUB_rule, c)
    }
}
void  State::_sub_Op_LoadUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUS_MEMORY_, _LoadUS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, loadUS_rule, c)
    }
}
void  State::_sub_Op_LoadD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION__SET_VALID(FREGD, loadD_rule, c)
    }
}
void  State::_sub_Op_LoadF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION__SET_VALID(FREGF, loadF_rule, c)
    }
}
void  State::_sub_Op_LoadI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADI_MEMORY_, _LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, loadI_rule, c)
    }
}
void  State::_sub_Op_LoadKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R11, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R12, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R13, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R14, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R15, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R16, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R28, loadKlass_rule, c)
    }
}
void  State::_sub_Op_LoadNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegN_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegN_rule, c)
    }
}
void  State::_sub_Op_LoadL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, loadL_rule, c)
    }
}
void  State::_sub_Op_LoadPLocked(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+ALU_COST * 2 + LOAD_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R11, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R12, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R13, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R14, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R15, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R16, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R28, loadPLocked_rule, c)
    }
}
void  State::_sub_Op_LoadP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R11, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R12, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R13, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R14, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R15, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R16, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R28, loadP_rule, c)
    }
}
void  State::_sub_Op_LoadN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegN_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegN_rule, c)
    }
}
void  State::_sub_Op_LoadRange(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, loadRange_rule, c)
    }
}
void  State::_sub_Op_LoadS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADS_MEMORY_, _LoadS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, loadS_rule, c)
    }
}
void  State::_sub_Op_MaxD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD] + DEFAULT_COST;
        DFA_PRODUCTION__SET_VALID(FREGD, maxD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MaxF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF] + DEFAULT_COST;
        DFA_PRODUCTION__SET_VALID(FREGF, maxF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MaxI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 337 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 5749 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, maxI_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, maxI_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, maxI_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, maxI_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, maxI_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, maxI_reg_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+BRANCH_COST + ALU_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, maxI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, maxI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, maxI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, maxI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, maxI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, maxI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_MemBarAcquire(const Node *n){
    {
      unsigned int c = ALU_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_rule, c)
    }
}
void  State::_sub_Op_LoadFence(const Node *n){
    {
      unsigned int c = ALU_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, load_fence_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquireLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarRelease(const Node *n){
    {
      unsigned int c = ALU_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_rule, c)
    }
}
void  State::_sub_Op_StoreFence(const Node *n){
    {
      unsigned int c = ALU_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, store_fence_rule, c)
    }
}
void  State::_sub_Op_MemBarReleaseLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarVolatile(const Node *n){
    {
      unsigned int c = ALU_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_volatile_rule, c)
    }
}
void  State::_sub_Op_MemBarStoreStore(const Node *n){
    {
      unsigned int c = ALU_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_storestore_rule, c)
    }
}
void  State::_sub_Op_MinD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD] + DEFAULT_COST;
        DFA_PRODUCTION__SET_VALID(FREGD, minD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MinF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF] + DEFAULT_COST;
        DFA_PRODUCTION__SET_VALID(FREGF, minF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MinI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 323 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 5862 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, minI_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, minI_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, minI_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, minI_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, minI_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, minI_reg_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+BRANCH_COST + ALU_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, minI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, minI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, minI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, minI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, minI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, minI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_ModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + IDIVSI_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, modI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, modI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, modI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, modI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, modI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, modI_rule, c)
    }
}
void  State::_sub_Op_ModL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + IDIVDI_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, modL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, modL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, modL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, modL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, modL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, modL_rule, c)
    }
}
void  State::_sub_Op_MoveI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(FREGF, MoveI2F_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + STORE_COST;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, MoveI2F_reg_stack_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI] + LOAD_COST;
      if (STATE__NOT_YET_VALID(FREGF) || _cost[FREGF] > c) {
        DFA_PRODUCTION__SET_VALID(FREGF, MoveI2F_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, MoveF2I_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + STORE_COST;
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, MoveF2I_reg_stack_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTF) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTF] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, MoveF2I_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(FREGD, MoveL2D_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + STORE_COST;
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, MoveL2D_reg_stack_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL] + LOAD_COST;
      if (STATE__NOT_YET_VALID(FREGD) || _cost[FREGD] > c) {
        DFA_PRODUCTION__SET_VALID(FREGD, MoveL2D_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, MoveD2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + STORE_COST;
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, MoveD2L_reg_stack_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTD) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTD] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, MoveD2L_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD] + FMUL_DOUBLE_COST;
        DFA_PRODUCTION__SET_VALID(FREGD, mulD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MulF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF] + FMUL_SINGLE_COST;
        DFA_PRODUCTION__SET_VALID(FREGF, mulF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MulHiL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + IMUL_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, mulHiL_rReg_rule, c)
    }
}
void  State::_sub_Op_MulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + IMUL_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, mulI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, mulI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, mulI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, mulI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, mulI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, mulI_rule, c)
    }
}
void  State::_sub_Op_MulL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + IMUL_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, mulL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, mulL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, mulL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, mulL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, mulL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, mulL_rule, c)
    }
}
void  State::_sub_Op_NegD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(FREGD, negD_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD];
        DFA_PRODUCTION__SET_VALID(_NEGD_FREGD_, _NegD_fRegD__rule, c)
    }
}
void  State::_sub_Op_NegF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + XFER_COST;
        DFA_PRODUCTION__SET_VALID(FREGF, negF_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF];
        DFA_PRODUCTION__SET_VALID(_NEGF_FREGF_, _NegF_fRegF__rule, c)
    }
}
void  State::_sub_Op_OrI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _XORI_IREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 422 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 6151 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORI_IREGI_IMMI_M1]+_kids[1]->_cost[IREGI] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, ornI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, ornI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, ornI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, ornI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, ornI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, ornI_reg_reg_b_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _XORI_IREGI_IMMI_M1) &&
        (
#line 422 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 6169 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_XORI_IREGI_IMMI_M1] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, ornI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, ornI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, ornI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, ornI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, ornI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, ornI_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMIADD) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMIADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, orI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, orI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, orI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, orI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, orI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, orI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, orI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_OrL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _XORL_IREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 438 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 6275 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORL_IREGL_IMML_M1]+_kids[1]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, ornL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, ornL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, ornL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, ornL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, ornL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, ornL_reg_reg_b_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _XORL_IREGL_IMML_M1) &&
        (
#line 438 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 6292 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_XORL_IREGL_IMML_M1] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, ornL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, ornL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, ornL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, ornL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, ornL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, ornL_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLADD) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, orL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, orL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, orL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, orL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, orL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, orL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, orL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, orL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, orL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, orL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, orL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, orL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_PartialSubtypeCheck(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_R14) && STATE__VALID_CHILD(_kids[1], IREGP_R10) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R14]+_kids[1]->_cost[IREGP_R10];
        DFA_PRODUCTION__SET_VALID(_PARTIALSUBTYPECHECK_IREGP_R14_IREGP_R10, _PartialSubtypeCheck_iRegP_R14_iRegP_R10_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R14) && STATE__VALID_CHILD(_kids[1], IREGP_R10) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R14]+_kids[1]->_cost[IREGP_R10]+2 * STORE_COST + 3 * LOAD_COST + 4 * ALU_COST + BRANCH_COST * 4;
        DFA_PRODUCTION__SET_VALID(IREGP_R15, partialSubtypeCheck_rule, c)
    }
}
void  State::_sub_Op_PopCountI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 293 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UsePopCountInstruction
#line 6399 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, popCountI_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, popCountI_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, popCountI_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, popCountI_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, popCountI_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, popCountI_b_rule, c)
    }
}
void  State::_sub_Op_PopCountL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) &&
        (
#line 308 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UsePopCountInstruction
#line 6419 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, popCountL_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, popCountL_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, popCountL_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, popCountL_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, popCountL_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, popCountL_b_rule, c)
    }
}
void  State::_sub_Op_RShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        (
#line 60 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 6439 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI_16]+_kids[1]->_cost[IMMI_16] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convI2S_reg_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, convI2S_reg_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, convI2S_reg_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, convI2S_reg_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, convI2S_reg_reg_b_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, convI2S_reg_reg_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        (
#line 45 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 6457 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI_24]+_kids[1]->_cost[IMMI_24] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convB2I_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, convB2I_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, convB2I_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, convB2I_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, convB2I_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, convB2I_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, rShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, rShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, rShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, rShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, rShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, rShiftI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, rShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, rShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, rShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, rShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, rShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, rShiftI_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_31) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI_31];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI_IREGIORL2I_IMMI_31, _RShiftI_iRegIorL2I_immI_31_rule, c)
    }
}
void  State::_sub_Op_RShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, rShiftL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, rShiftL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, rShiftL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, rShiftL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, rShiftL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, rShiftL_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, rShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, rShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, rShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, rShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, rShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, rShiftL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI_63) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI_63];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL_IREGL_IMMI_63, _RShiftL_iRegL_immI_63_rule, c)
    }
}
void  State::_sub_Op_Rethrow(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, RethrowException_rule, c)
    }
}
void  State::_sub_Op_Return(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, Ret_rule, c)
    }
}
void  State::_sub_Op_SafePoint(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+2 * LOAD_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, safePoint_rule, c)
    }
}
void  State::_sub_Op_SqrtD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + FSQRT_COST;
        DFA_PRODUCTION__SET_VALID(FREGD, sqrtD_reg_rule, c)
    }
}
void  State::_sub_Op_SqrtF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + FSQRT_COST;
        DFA_PRODUCTION__SET_VALID(FREGF, sqrtF_reg_rule, c)
    }
}
void  State::_sub_Op_StoreB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0] + STORE_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeimmB0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGIORL2I] + STORE_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeB_rule, c)
      }
    }
}
void  State::_sub_Op_StoreC(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0] + STORE_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeimmC0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGIORL2I] + STORE_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeC_rule, c)
      }
    }
}
void  State::_sub_Op_StoreCM(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0]+ALU_COST + STORE_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeimmCM0_ordered_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) &&
        (
#line 4585 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
unnecessary_storestore(n)
#line 6673 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0] + STORE_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeimmCM0_rule, c)
      }
    }
}
void  State::_sub_Op_StorePConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+ALU_COST * 2 + STORE_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, storePConditional_rule, c)
    }
}
void  State::_sub_Op_StoreIConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_IREGI]+LOAD_COST + STORE_COST + BRANCH_COST * 2;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, storeIConditional_rule, c)
    }
}
void  State::_sub_Op_StoreLConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+LOAD_COST + STORE_COST + 2 * BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, storeLConditional_rule, c)
    }
}
void  State::_sub_Op_StoreD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[FREGD] + STORE_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeD_rule, c)
    }
}
void  State::_sub_Op_StoreF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[FREGF] + STORE_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF_rule, c)
    }
}
void  State::_sub_Op_StoreI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0] + STORE_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeimmI0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGIORL2I] + STORE_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeI_rule, c)
      }
    }
}
void  State::_sub_Op_StoreL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMML0] + STORE_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeimmL0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGL] + STORE_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL_rule, c)
      }
    }
}
void  State::_sub_Op_StoreP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMP0] + STORE_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeimmP0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGP] + STORE_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeP_rule, c)
      }
    }
}
void  State::_sub_Op_StoreN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMN0) &&
        (
#line 4785 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
Universe::narrow_oop_base() == NULL &&
            Universe::narrow_klass_base() == NULL
#line 6753 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMN0] + STORE_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmN0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGN] + STORE_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeN_rule, c)
      }
    }
}
void  State::_sub_Op_StoreNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGN] + STORE_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeNKlass_rule, c)
    }
}
void  State::_sub_Op_StrComp(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 9822 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
((StrCompNode *)n)->encoding() == StrIntrinsicNode::LU
#line 6776 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
        DFA_PRODUCTION__SET_VALID(IREGI_R10, string_compareLU_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 9804 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
((StrCompNode *)n)->encoding() == StrIntrinsicNode::UL
#line 6785 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, string_compareUL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 9787 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
((StrCompNode *)n)->encoding() == StrIntrinsicNode::LL
#line 6796 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, string_compareL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 9769 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
((StrCompNode *)n)->encoding() == StrIntrinsicNode::UU
#line 6807 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, string_compareU_rule, c)
      }
    }
}
void  State::_sub_Op_StrEquals(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGP_R13) && STATE__VALID_CHILD(_kids[1], IREGI_R14) &&
        (
#line 10036 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
((StrEqualsNode*)n)->encoding() == StrIntrinsicNode::UU
#line 6820 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGP_R13]+_kids[1]->_cost[IREGI_R14] + DEFAULT_COST;
        DFA_PRODUCTION__SET_VALID(IREGI_R10, string_equalsU_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGP_R13) && STATE__VALID_CHILD(_kids[1], IREGI_R14) &&
        (
#line 10020 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
((StrEqualsNode*)n)->encoding() == StrIntrinsicNode::LL
#line 6829 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGP_R13]+_kids[1]->_cost[IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, string_equalsL_rule, c)
      }
    }
}
void  State::_sub_Op_StrIndexOf(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IMMI_1) &&
        (
#line 9946 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UL
#line 6842 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IMMI_1] + DEFAULT_COST;
        DFA_PRODUCTION__SET_VALID(IREGI_R10, string_indexof_conUL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IMMI_LE_4) &&
        (
#line 9925 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::LL
#line 6851 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IMMI_LE_4] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, string_indexof_conLL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IMMI_LE_4) &&
        (
#line 9903 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UU
#line 6862 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IMMI_LE_4] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, string_indexof_conUU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 9882 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UL
#line 6873 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, string_indexofUL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 9861 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::LL
#line 6884 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, string_indexofLL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 9840 "/home/lkp/rpmbuild/BUILD/java-11-openjdk-11.0.24.8-3.oe2409.riscv64/openjdk/src/hotspot/cpu/riscv/riscv.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UU
#line 6895 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, string_indexofUU_rule, c)
      }
    }
}
void  State::_sub_Op_StrIndexOfChar(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[IREGI_R13] + DEFAULT_COST;
        DFA_PRODUCTION__SET_VALID(IREGI_R10, stringU_indexof_char_rule, c)
    }
}
void  State::_sub_Op_SubD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD] + FMUL_DOUBLE_COST;
        DFA_PRODUCTION__SET_VALID(FREGD, subD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_SubF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF] + FMUL_SINGLE_COST;
        DFA_PRODUCTION__SET_VALID(FREGF, subF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_SubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, negI_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, negI_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, negI_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, negI_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, negI_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, negI_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMISUB) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMISUB] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, subI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, subI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, subI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, subI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, subI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, subI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, subI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, subI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, subI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, subI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, subI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, subI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_SubL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, negL_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, negL_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, negL_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, negL_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, negL_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, negL_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLSUB) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLSUB] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, subL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, subL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, subL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, subL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, subL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, subL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, subL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, subL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, subL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, subL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, subL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, subL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_TailCall(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGPNOSP) && STATE__VALID_CHILD(_kids[1], INLINE_CACHE_REGP) ) {
      unsigned int c = _kids[0]->_cost[IREGPNOSP]+_kids[1]->_cost[INLINE_CACHE_REGP] + BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, TailCalljmpInd_rule, c)
    }
}
void  State::_sub_Op_TailJump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGPNOSP) && STATE__VALID_CHILD(_kids[1], IREGP_R10) ) {
      unsigned int c = _kids[0]->_cost[IREGPNOSP]+_kids[1]->_cost[IREGP_R10]+ALU_COST + BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, TailjmpInd_rule, c)
    }
}
void  State::_sub_Op_ThreadLocal(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(JAVATHREAD_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegP_rule, c)
    }
}
void  State::_sub_Op_URShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, urShiftI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, urShiftI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, urShiftI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, urShiftI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, urShiftI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, urShiftI_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, urShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, urShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, urShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, urShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, urShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, urShiftI_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTI_IREGIORL2I_IMMI_31) && STATE__VALID_CHILD(_kids[1], IMMI_31) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTI_IREGIORL2I_IMMI_31]+_kids[1]->_cost[IMMI_31] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, signExtract_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, signExtract_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, signExtract_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, signExtract_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, signExtract_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, signExtract_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_IREGP_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_IREGP_]+_kids[1]->_cost[IMMI] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, urShiftP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, urShiftP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, urShiftP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, urShiftP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, urShiftP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, urShiftP_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, urShiftL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, urShiftL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, urShiftL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, urShiftL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, urShiftL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, urShiftL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, urShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, urShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, urShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, urShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, urShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, urShiftL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL_IREGL_IMMI_63) && STATE__VALID_CHILD(_kids[1], IMMI_63) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL_IREGL_IMMI_63]+_kids[1]->_cost[IMMI_63] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, signExtractL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, signExtractL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, signExtractL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, signExtractL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, signExtractL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, signExtractL_rule, c)
      }
    }
}
void  State::_sub_Op_XorI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_XORI_IREGI_IMMI_M1, _XorI_iRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMIADD) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMIADD] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, xorI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, xorI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R10, xorI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R12, xorI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R13, xorI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R14, xorI_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, xorI_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI_M1] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, regI_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, regI_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R10, regI_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R12, regI_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R13, regI_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R14, regI_not_reg_rule, c)
      }
    }
}
void  State::_sub_Op_XorL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_XORL_IREGL_IMML_M1, _XorL_iRegL_immL_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLADD) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLADD] + ALU_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, xorL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, xorL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R28, xorL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R29, xorL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R30, xorL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R10, xorL_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, xorL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, xorL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, xorL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, xorL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, xorL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, xorL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML_M1] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, regL_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, regL_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R28, regL_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R29, regL_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R30, regL_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R10, regL_not_reg_rule, c)
      }
    }
}
bool State::DFA(int opcode, const Node *n) {
  switch(opcode) {
  case Op_RegN: { _sub_Op_RegN(n);
    break;
  }
  case Op_RegI: { _sub_Op_RegI(n);
    break;
  }
  case Op_RegP: { _sub_Op_RegP(n);
    break;
  }
  case Op_RegF: { _sub_Op_RegF(n);
    break;
  }
  case Op_RegD: { _sub_Op_RegD(n);
    break;
  }
  case Op_RegL: { _sub_Op_RegL(n);
    break;
  }
  case Op_RegFlags: { _sub_Op_RegFlags(n);
    break;
  }
  case Op_AbsD: { _sub_Op_AbsD(n);
    break;
  }
  case Op_AbsF: { _sub_Op_AbsF(n);
    break;
  }
  case Op_AbsI: { _sub_Op_AbsI(n);
    break;
  }
  case Op_AbsL: { _sub_Op_AbsL(n);
    break;
  }
  case Op_AddD: { _sub_Op_AddD(n);
    break;
  }
  case Op_AddF: { _sub_Op_AddF(n);
    break;
  }
  case Op_AddI: { _sub_Op_AddI(n);
    break;
  }
  case Op_AddL: { _sub_Op_AddL(n);
    break;
  }
  case Op_AddP: { _sub_Op_AddP(n);
    break;
  }
  case Op_AndI: { _sub_Op_AndI(n);
    break;
  }
  case Op_AndL: { _sub_Op_AndL(n);
    break;
  }
  case Op_AryEq: { _sub_Op_AryEq(n);
    break;
  }
  case Op_Binary: { _sub_Op_Binary(n);
    break;
  }
  case Op_Bool: { _sub_Op_Bool(n);
    break;
  }
  case Op_ReverseBytesI: { _sub_Op_ReverseBytesI(n);
    break;
  }
  case Op_ReverseBytesL: { _sub_Op_ReverseBytesL(n);
    break;
  }
  case Op_ReverseBytesUS: { _sub_Op_ReverseBytesUS(n);
    break;
  }
  case Op_ReverseBytesS: { _sub_Op_ReverseBytesS(n);
    break;
  }
  case Op_CallDynamicJava: { _sub_Op_CallDynamicJava(n);
    break;
  }
  case Op_CallLeaf: { _sub_Op_CallLeaf(n);
    break;
  }
  case Op_CallLeafNoFP: { _sub_Op_CallLeafNoFP(n);
    break;
  }
  case Op_CallRuntime: { _sub_Op_CallRuntime(n);
    break;
  }
  case Op_CallStaticJava: { _sub_Op_CallStaticJava(n);
    break;
  }
  case Op_CastII: { _sub_Op_CastII(n);
    break;
  }
  case Op_CastX2P: { _sub_Op_CastX2P(n);
    break;
  }
  case Op_CastP2X: { _sub_Op_CastP2X(n);
    break;
  }
  case Op_CastPP: { _sub_Op_CastPP(n);
    break;
  }
  case Op_CheckCastPP: { _sub_Op_CheckCastPP(n);
    break;
  }
  case Op_ClearArray: { _sub_Op_ClearArray(n);
    break;
  }
  case Op_CMoveI: { _sub_Op_CMoveI(n);
    break;
  }
  case Op_CMoveL: { _sub_Op_CMoveL(n);
    break;
  }
  case Op_CmpN: { _sub_Op_CmpN(n);
    break;
  }
  case Op_CmpD: { _sub_Op_CmpD(n);
    break;
  }
  case Op_CmpD3: { _sub_Op_CmpD3(n);
    break;
  }
  case Op_CmpF: { _sub_Op_CmpF(n);
    break;
  }
  case Op_CmpF3: { _sub_Op_CmpF3(n);
    break;
  }
  case Op_CmpI: { _sub_Op_CmpI(n);
    break;
  }
  case Op_CmpL: { _sub_Op_CmpL(n);
    break;
  }
  case Op_CmpL3: { _sub_Op_CmpL3(n);
    break;
  }
  case Op_CmpLTMask: { _sub_Op_CmpLTMask(n);
    break;
  }
  case Op_CmpP: { _sub_Op_CmpP(n);
    break;
  }
  case Op_CmpU: { _sub_Op_CmpU(n);
    break;
  }
  case Op_CmpUL: { _sub_Op_CmpUL(n);
    break;
  }
  case Op_CompareAndSwapB: { _sub_Op_CompareAndSwapB(n);
    break;
  }
  case Op_CompareAndSwapS: { _sub_Op_CompareAndSwapS(n);
    break;
  }
  case Op_CompareAndSwapI: { _sub_Op_CompareAndSwapI(n);
    break;
  }
  case Op_CompareAndSwapL: { _sub_Op_CompareAndSwapL(n);
    break;
  }
  case Op_CompareAndSwapP: { _sub_Op_CompareAndSwapP(n);
    break;
  }
  case Op_CompareAndSwapN: { _sub_Op_CompareAndSwapN(n);
    break;
  }
  case Op_WeakCompareAndSwapB: { _sub_Op_WeakCompareAndSwapB(n);
    break;
  }
  case Op_WeakCompareAndSwapS: { _sub_Op_WeakCompareAndSwapS(n);
    break;
  }
  case Op_WeakCompareAndSwapI: { _sub_Op_WeakCompareAndSwapI(n);
    break;
  }
  case Op_WeakCompareAndSwapL: { _sub_Op_WeakCompareAndSwapL(n);
    break;
  }
  case Op_WeakCompareAndSwapP: { _sub_Op_WeakCompareAndSwapP(n);
    break;
  }
  case Op_WeakCompareAndSwapN: { _sub_Op_WeakCompareAndSwapN(n);
    break;
  }
  case Op_CompareAndExchangeB: { _sub_Op_CompareAndExchangeB(n);
    break;
  }
  case Op_CompareAndExchangeS: { _sub_Op_CompareAndExchangeS(n);
    break;
  }
  case Op_CompareAndExchangeI: { _sub_Op_CompareAndExchangeI(n);
    break;
  }
  case Op_CompareAndExchangeL: { _sub_Op_CompareAndExchangeL(n);
    break;
  }
  case Op_CompareAndExchangeP: { _sub_Op_CompareAndExchangeP(n);
    break;
  }
  case Op_CompareAndExchangeN: { _sub_Op_CompareAndExchangeN(n);
    break;
  }
  case Op_GetAndAddI: { _sub_Op_GetAndAddI(n);
    break;
  }
  case Op_GetAndAddL: { _sub_Op_GetAndAddL(n);
    break;
  }
  case Op_GetAndSetI: { _sub_Op_GetAndSetI(n);
    break;
  }
  case Op_GetAndSetL: { _sub_Op_GetAndSetL(n);
    break;
  }
  case Op_GetAndSetP: { _sub_Op_GetAndSetP(n);
    break;
  }
  case Op_GetAndSetN: { _sub_Op_GetAndSetN(n);
    break;
  }
  case Op_ConN: { _sub_Op_ConN(n);
    break;
  }
  case Op_ConNKlass: { _sub_Op_ConNKlass(n);
    break;
  }
  case Op_ConD: { _sub_Op_ConD(n);
    break;
  }
  case Op_ConF: { _sub_Op_ConF(n);
    break;
  }
  case Op_ConI: { _sub_Op_ConI(n);
    break;
  }
  case Op_ConL: { _sub_Op_ConL(n);
    break;
  }
  case Op_ConP: { _sub_Op_ConP(n);
    break;
  }
  case Op_Conv2B: { _sub_Op_Conv2B(n);
    break;
  }
  case Op_ConvD2F: { _sub_Op_ConvD2F(n);
    break;
  }
  case Op_ConvD2I: { _sub_Op_ConvD2I(n);
    break;
  }
  case Op_ConvD2L: { _sub_Op_ConvD2L(n);
    break;
  }
  case Op_ConvF2D: { _sub_Op_ConvF2D(n);
    break;
  }
  case Op_ConvF2I: { _sub_Op_ConvF2I(n);
    break;
  }
  case Op_ConvF2L: { _sub_Op_ConvF2L(n);
    break;
  }
  case Op_ConvI2D: { _sub_Op_ConvI2D(n);
    break;
  }
  case Op_ConvI2F: { _sub_Op_ConvI2F(n);
    break;
  }
  case Op_ConvI2L: { _sub_Op_ConvI2L(n);
    break;
  }
  case Op_ConvL2D: { _sub_Op_ConvL2D(n);
    break;
  }
  case Op_ConvL2F: { _sub_Op_ConvL2F(n);
    break;
  }
  case Op_ConvL2I: { _sub_Op_ConvL2I(n);
    break;
  }
  case Op_CountedLoopEnd: { _sub_Op_CountedLoopEnd(n);
    break;
  }
  case Op_CountLeadingZerosI: { _sub_Op_CountLeadingZerosI(n);
    break;
  }
  case Op_CountLeadingZerosL: { _sub_Op_CountLeadingZerosL(n);
    break;
  }
  case Op_CountTrailingZerosI: { _sub_Op_CountTrailingZerosI(n);
    break;
  }
  case Op_CountTrailingZerosL: { _sub_Op_CountTrailingZerosL(n);
    break;
  }
  case Op_CreateEx: { _sub_Op_CreateEx(n);
    break;
  }
  case Op_DecodeN: { _sub_Op_DecodeN(n);
    break;
  }
  case Op_DecodeNKlass: { _sub_Op_DecodeNKlass(n);
    break;
  }
  case Op_DivD: { _sub_Op_DivD(n);
    break;
  }
  case Op_DivF: { _sub_Op_DivF(n);
    break;
  }
  case Op_DivI: { _sub_Op_DivI(n);
    break;
  }
  case Op_DivL: { _sub_Op_DivL(n);
    break;
  }
  case Op_EncodeP: { _sub_Op_EncodeP(n);
    break;
  }
  case Op_EncodePKlass: { _sub_Op_EncodePKlass(n);
    break;
  }
  case Op_FastLock: { _sub_Op_FastLock(n);
    break;
  }
  case Op_FastUnlock: { _sub_Op_FastUnlock(n);
    break;
  }
  case Op_FmaD: { _sub_Op_FmaD(n);
    break;
  }
  case Op_FmaF: { _sub_Op_FmaF(n);
    break;
  }
  case Op_Goto: { _sub_Op_Goto(n);
    break;
  }
  case Op_Halt: { _sub_Op_Halt(n);
    break;
  }
  case Op_If: { _sub_Op_If(n);
    break;
  }
  case Op_LShiftI: { _sub_Op_LShiftI(n);
    break;
  }
  case Op_LShiftL: { _sub_Op_LShiftL(n);
    break;
  }
  case Op_LoadB: { _sub_Op_LoadB(n);
    break;
  }
  case Op_LoadUB: { _sub_Op_LoadUB(n);
    break;
  }
  case Op_LoadUS: { _sub_Op_LoadUS(n);
    break;
  }
  case Op_LoadD: { _sub_Op_LoadD(n);
    break;
  }
  case Op_LoadF: { _sub_Op_LoadF(n);
    break;
  }
  case Op_LoadI: { _sub_Op_LoadI(n);
    break;
  }
  case Op_LoadKlass: { _sub_Op_LoadKlass(n);
    break;
  }
  case Op_LoadNKlass: { _sub_Op_LoadNKlass(n);
    break;
  }
  case Op_LoadL: { _sub_Op_LoadL(n);
    break;
  }
  case Op_LoadPLocked: { _sub_Op_LoadPLocked(n);
    break;
  }
  case Op_LoadP: { _sub_Op_LoadP(n);
    break;
  }
  case Op_LoadN: { _sub_Op_LoadN(n);
    break;
  }
  case Op_LoadRange: { _sub_Op_LoadRange(n);
    break;
  }
  case Op_LoadS: { _sub_Op_LoadS(n);
    break;
  }
  case Op_MaxD: { _sub_Op_MaxD(n);
    break;
  }
  case Op_MaxF: { _sub_Op_MaxF(n);
    break;
  }
  case Op_MaxI: { _sub_Op_MaxI(n);
    break;
  }
  case Op_MemBarAcquire: { _sub_Op_MemBarAcquire(n);
    break;
  }
  case Op_LoadFence: { _sub_Op_LoadFence(n);
    break;
  }
  case Op_MemBarAcquireLock: { _sub_Op_MemBarAcquireLock(n);
    break;
  }
  case Op_MemBarRelease: { _sub_Op_MemBarRelease(n);
    break;
  }
  case Op_StoreFence: { _sub_Op_StoreFence(n);
    break;
  }
  case Op_MemBarReleaseLock: { _sub_Op_MemBarReleaseLock(n);
    break;
  }
  case Op_MemBarVolatile: { _sub_Op_MemBarVolatile(n);
    break;
  }
  case Op_MemBarStoreStore: { _sub_Op_MemBarStoreStore(n);
    break;
  }
  case Op_MinD: { _sub_Op_MinD(n);
    break;
  }
  case Op_MinF: { _sub_Op_MinF(n);
    break;
  }
  case Op_MinI: { _sub_Op_MinI(n);
    break;
  }
  case Op_ModI: { _sub_Op_ModI(n);
    break;
  }
  case Op_ModL: { _sub_Op_ModL(n);
    break;
  }
  case Op_MoveI2F: { _sub_Op_MoveI2F(n);
    break;
  }
  case Op_MoveF2I: { _sub_Op_MoveF2I(n);
    break;
  }
  case Op_MoveL2D: { _sub_Op_MoveL2D(n);
    break;
  }
  case Op_MoveD2L: { _sub_Op_MoveD2L(n);
    break;
  }
  case Op_MulD: { _sub_Op_MulD(n);
    break;
  }
  case Op_MulF: { _sub_Op_MulF(n);
    break;
  }
  case Op_MulHiL: { _sub_Op_MulHiL(n);
    break;
  }
  case Op_MulI: { _sub_Op_MulI(n);
    break;
  }
  case Op_MulL: { _sub_Op_MulL(n);
    break;
  }
  case Op_NegD: { _sub_Op_NegD(n);
    break;
  }
  case Op_NegF: { _sub_Op_NegF(n);
    break;
  }
  case Op_OrI: { _sub_Op_OrI(n);
    break;
  }
  case Op_OrL: { _sub_Op_OrL(n);
    break;
  }
  case Op_PartialSubtypeCheck: { _sub_Op_PartialSubtypeCheck(n);
    break;
  }
  case Op_PopCountI: { _sub_Op_PopCountI(n);
    break;
  }
  case Op_PopCountL: { _sub_Op_PopCountL(n);
    break;
  }
  case Op_RShiftI: { _sub_Op_RShiftI(n);
    break;
  }
  case Op_RShiftL: { _sub_Op_RShiftL(n);
    break;
  }
  case Op_Rethrow: { _sub_Op_Rethrow(n);
    break;
  }
  case Op_Return: { _sub_Op_Return(n);
    break;
  }
  case Op_SafePoint: { _sub_Op_SafePoint(n);
    break;
  }
  case Op_SqrtD: { _sub_Op_SqrtD(n);
    break;
  }
  case Op_SqrtF: { _sub_Op_SqrtF(n);
    break;
  }
  case Op_StoreB: { _sub_Op_StoreB(n);
    break;
  }
  case Op_StoreC: { _sub_Op_StoreC(n);
    break;
  }
  case Op_StoreCM: { _sub_Op_StoreCM(n);
    break;
  }
  case Op_StorePConditional: { _sub_Op_StorePConditional(n);
    break;
  }
  case Op_StoreIConditional: { _sub_Op_StoreIConditional(n);
    break;
  }
  case Op_StoreLConditional: { _sub_Op_StoreLConditional(n);
    break;
  }
  case Op_StoreD: { _sub_Op_StoreD(n);
    break;
  }
  case Op_StoreF: { _sub_Op_StoreF(n);
    break;
  }
  case Op_StoreI: { _sub_Op_StoreI(n);
    break;
  }
  case Op_StoreL: { _sub_Op_StoreL(n);
    break;
  }
  case Op_StoreP: { _sub_Op_StoreP(n);
    break;
  }
  case Op_StoreN: { _sub_Op_StoreN(n);
    break;
  }
  case Op_StoreNKlass: { _sub_Op_StoreNKlass(n);
    break;
  }
  case Op_StrComp: { _sub_Op_StrComp(n);
    break;
  }
  case Op_StrEquals: { _sub_Op_StrEquals(n);
    break;
  }
  case Op_StrIndexOf: { _sub_Op_StrIndexOf(n);
    break;
  }
  case Op_StrIndexOfChar: { _sub_Op_StrIndexOfChar(n);
    break;
  }
  case Op_SubD: { _sub_Op_SubD(n);
    break;
  }
  case Op_SubF: { _sub_Op_SubF(n);
    break;
  }
  case Op_SubI: { _sub_Op_SubI(n);
    break;
  }
  case Op_SubL: { _sub_Op_SubL(n);
    break;
  }
  case Op_TailCall: { _sub_Op_TailCall(n);
    break;
  }
  case Op_TailJump: { _sub_Op_TailJump(n);
    break;
  }
  case Op_ThreadLocal: { _sub_Op_ThreadLocal(n);
    break;
  }
  case Op_URShiftI: { _sub_Op_URShiftI(n);
    break;
  }
  case Op_URShiftL: { _sub_Op_URShiftL(n);
    break;
  }
  case Op_XorI: { _sub_Op_XorI(n);
    break;
  }
  case Op_XorL: { _sub_Op_XorL(n);
    break;
  }
  
  default:
    tty->print("Default case invoked for: \n");
    tty->print("   opcode  = %d, \"%s\"\n", opcode, NodeClassNames[opcode]);
    return false;
  }
  return true;
}
